package com.main;

import com.methods.RequestResponse;
import java.io.IOException;
import java.io.InputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;
import org.apache.log4j.Logger;

public class Scheduler implements Runnable {
  static Logger log = Logger.getLogger(Scheduler.class.getName());
  public static Properties prop = new Properties();

  public void run() {
    InputStream input = null;
    try {
      input = Scheduler.class.getClass().getResourceAsStream("/Properties.properties");

      prop.load(input);
    } catch (IOException ex) {

      log.error(ex.getMessage());
    } finally {
      if (input != null) {
        try {
          input.close();
        } catch (IOException e) {
          log.error(e.getMessage());
        }

      } else {

        log.error(
            "Either no properties file found or error in properties file path in Scheduler class");
      }
    }

    Date date = new Date();

    DateFormat sdf = new SimpleDateFormat("yyyyMMdd");
    Calendar cal = Calendar.getInstance();
    String dateToday = sdf.format(cal.getTime());

    log.info("Inward Scheduled Run Begins...." + new Date());
    try {
      ArrayList<String> requestBodyList = RequestResponse.getRequestBody();
      for (int i = 0; i < requestBodyList.size(); i++) {

        log.info("Iterating for Next Bank API");

        try {
          RequestResponse.get_response(requestBodyList.get(i), dateToday);
        } catch (IOException e) {
          log.error(String.valueOf(e.getMessage()) + " for " + (String) requestBodyList.get(i));
        }
      }
    } catch (Exception e) {

      log.error(String.valueOf(e.getMessage()) + " error in line no 78 scheduler class");
    }

    log.info("End of Scheduled Run");
  }
}
